local CrashSkinCheck = CrashAddon.CrashSkinCheck
local SpeedCalc = CrashAddon.SpeedCalc
local StateSetter = CrashAddon.StateSetter
local FailVibeCheck = CrashAddon.FailVibeCheck
local ActionButton = CrashAddon.ActionButton

//a fairly simple implementation of the crash dash, this time pulled from mach
local function CrashDash(player)
	if not CrashSkinCheck(player)
		return
	end
	
	//this resets everything and prevents moves if crash fails the vibe check
	if FailVibeCheck(player)
		player.normalspeed = skins[player.mo.skin].normalspeed
		player.acceleration = skins[player.mo.skin].acceleration
		player.crashban.woah = false
		return
	end
	
	if player.cmd.buttons & BT_CUSTOM3 and P_IsObjectOnGround(player.mo) and
			not (player.cmd.buttons & ActionButton(player) or 
			player.powers[pw_sneakers])
		player.normalspeed = 36 * FRACUNIT
		player.acceleration = skins[player.mo.skin].acceleration * 2
	elseif not (player.cmd.buttons & ActionButton(player))
		player.normalspeed = skins[player.mo.skin].normalspeed
		player.acceleration = skins[player.mo.skin].acceleration
	end
	
	//also funny easter egg
	if (player.cmd.buttons & BT_CUSTOM3 and player.cmd.buttons & BT_TOSSFLAG) and
			P_IsObjectOnGround(player.mo) and SpeedCalc(player) == 0
		if not player.crashban.woah
			S_StartSound(player.mo, sfx_woah)
			player.crashban.woah = true
		end
	elseif not P_IsObjectOnGround(player.mo) or SpeedCalc(player) != 0 and 
			player.crashban.woah
		player.crashban.woah = false
	end
	if player.crashban.woah
		StateSetter(player.mo, S_PLAY_FLY_TIRED)
	end
end

//hooks
addHook("PlayerThink", CrashDash)